/***************************************************************************
 *   Copyright (C) 2007 by Saritha Kalyanam   				   *
 *   sari.kaly@gmail.com   						   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __AZUREUS_DHT_H__
#define __AZUREUS_DHT_H__

#include "types.h"
#include "dht.h"
#include "task.h"
#include "azureus_node.h"
#include "azureus_db.h"
#include "queue.h"


struct azureus_dht {
    struct dht                  dht;
    u32                         trans_id;
    u8                          proto_ver;
    u32                         network;
    u32                         instance_id;
    u32                         est_dht_size;
    struct azureus_node         *this_node;
    TAILQ_HEAD(db_list_head, azureus_db_item)    db_list;
};

static inline struct azureus_dht *
azureus_dht_get_ref(struct dht *dht)
{
    return container_of(dht, struct azureus_dht, dht);
}

struct dht * azureus_dht_new(struct dht_net_if *nif, int port);
void azureus_dht_delete(struct dht *dht);
int azureus_dht_put(struct dht *dht, struct tinydht_msg *msg);
int azureus_dht_get(struct dht *dht, struct tinydht_msg *msg);
int azureus_task_schedule(struct task *task);

#endif /* __AZUREUS_DHT_H__ */
